/* slurp-example-simple.c
 *
 * Copyright (C) 2017 Julian Richen
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <slurp/slurp.h>
//#include <slurp/slurp-download.h>

int
main (int    argc,
      char **argv)
{
    SlurpResource *resource = NULL;
    SlurpDownload *download = NULL;
    GCancellable *cancellable = NULL;
    GError *error = NULL;
    gchar *source;
    gchar *target;
    gboolean overwrite;

    source = "https://www.google.com/images/branding/googlelogo/1x/googlelogo_color_272x92dp.png";
    target = "/home/julian/Downloads/temp/";
    overwrite = FALSE;
/*
    resource = slurp_resource_new ();
    slurp_resource_set_source_from_uri (resource, g_strdup (source));
    slurp_resource_set_target_from_uri (resource, g_strdup (target));
    slurp_resource_set_overwrite (resource, overwrite);
*/
    resource = g_object_new (SLURP_TYPE_RESOURCE,
                             "source", g_file_new_for_uri (source),
                             "target", g_file_new_for_uri (target),
                             "overwrite", overwrite,
                             NULL);

    cancellable = g_cancellable_new ();

    g_print ("SOURCE: %s\n", g_file_get_uri (slurp_resource_get_source (resource)));
    g_print ("TARGET: %s\n", g_file_get_uri (slurp_resource_get_target (resource)));

    download = slurp_download_new ();

    if (!slurp_download_resource_is_valid (download, cancellable, &error))
    {
        g_print ("Error: %s", error->message);

        g_object_unref (resource);
    }
}
