/* slurp-download-data.h
 *
 * Copyright © 2018 Julian Richen <julian@richen.io>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#pragma once

#include "slurp-resource.h"

#include <glib-object.h>
#include <glib.h>
#include <gio/gio.h>
#include <libsoup/soup.h>

G_BEGIN_DECLS

#define SLURP_TYPE_DOWNLOAD_DATA (slurp_download_data_get_type())

typedef struct _SlurpDownloadData SlurpDownloadData;

struct _SlurpDownloadData
{
    guint ref_count;

    SlurpResource *resource;
    GMainLoop *loop;
    gchar buffer[6144]; // 6 * 1024
    GInputStream *input;
    GOutputStream *output;
};

SlurpDownloadData *
slurp_download_data_new (void);

SlurpDownloadData *
slurp_download_data_copy (SlurpDownloadData *self);

SlurpDownloadData *
slurp_download_data_ref (SlurpDownloadData *self);

void
slurp_download_data_unref (SlurpDownloadData *self);

G_DEFINE_AUTOPTR_CLEANUP_FUNC (SlurpDownloadData, slurp_download_data_unref)

G_END_DECLS
